git-fetch.shon commit Merge git://git.kernel.org/pub/scm/gitk/gitk (9086a18)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14no_tags=
  15tags=
  16append=
  17force=
  18verbose=
  19update_head_ok=
  20exec=
  21upload_pack=
  22while case "$#" in 0) break ;; esac
  23do
  24        case "$1" in
  25        -a|--a|--ap|--app|--appe|--appen|--append)
  26                append=t
  27                ;;
  28        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  29        --upload-pa|--upload-pac|--upload-pack)
  30                shift
  31                exec="--exec=$1" 
  32                upload_pack="-u $1"
  33                ;;
  34        -f|--f|--fo|--for|--forc|--force)
  35                force=t
  36                ;;
  37        -t|--t|--ta|--tag|--tags)
  38                tags=t
  39                ;;
  40        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  41                no_tags=t
  42                ;;
  43        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  44        --update-he|--update-hea|--update-head|--update-head-|\
  45        --update-head-o|--update-head-ok)
  46                update_head_ok=t
  47                ;;
  48        -v|--verbose)
  49                verbose=Yes
  50                ;;
  51        -k|--k|--ke|--kee|--keep)
  52                keep=--keep
  53                ;;
  54        -*)
  55                usage
  56                ;;
  57        *)
  58                break
  59                ;;
  60        esac
  61        shift
  62done
  63
  64case "$#" in
  650)
  66        test -f "$GIT_DIR/branches/origin" ||
  67                test -f "$GIT_DIR/remotes/origin" ||
  68                        die "Where do you want to fetch from today?"
  69        set origin ;;
  70esac
  71
  72remote_nick="$1"
  73remote=$(get_remote_url "$@")
  74refs=
  75rref=
  76rsync_slurped_objects=
  77
  78if test "" = "$append"
  79then
  80        : >"$GIT_DIR/FETCH_HEAD"
  81fi
  82
  83append_fetch_head () {
  84    head_="$1"
  85    remote_="$2"
  86    remote_name_="$3"
  87    remote_nick_="$4"
  88    local_name_="$5"
  89    case "$6" in
  90    t) not_for_merge_='not-for-merge' ;;
  91    '') not_for_merge_= ;;
  92    esac
  93
  94    # remote-nick is the URL given on the command line (or a shorthand)
  95    # remote-name is the $GIT_DIR relative refs/ path we computed
  96    # for this refspec.
  97    case "$remote_name_" in
  98    HEAD)
  99        note_= ;;
 100    refs/heads/*)
 101        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 102        note_="branch '$note_' of " ;;
 103    refs/tags/*)
 104        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 105        note_="tag '$note_' of " ;;
 106    *)
 107        note_="$remote_name of " ;;
 108    esac
 109    remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
 110        remote_="$remote_1_"
 111    note_="$note_$remote_"
 112
 113    # 2.6.11-tree tag would not be happy to be fed to resolve.
 114    if git-cat-file commit "$head_" >/dev/null 2>&1
 115    then
 116        headc_=$(git-rev-parse --verify "$head_^0") || exit
 117        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 118        [ "$verbose" ] && echo >&2 "* committish: $head_"
 119        [ "$verbose" ] && echo >&2 "  $note_"
 120    else
 121        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 122        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 123        [ "$verbose" ] && echo >&2 "  $note_"
 124    fi
 125    if test "$local_name_" != ""
 126    then
 127        # We are storing the head locally.  Make sure that it is
 128        # a fast forward (aka "reverse push").
 129        fast_forward_local "$local_name_" "$head_" "$note_"
 130    fi
 131}
 132
 133fast_forward_local () {
 134    mkdir -p "$(dirname "$GIT_DIR/$1")"
 135    case "$1" in
 136    refs/tags/*)
 137        # Tags need not be pointing at commits so there
 138        # is no way to guarantee "fast-forward" anyway.
 139        if test -f "$GIT_DIR/$1"
 140        then
 141                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 142                then
 143                        [ "$verbose" ] && echo >&2 "* $1: same as $3"
 144                else
 145                        echo >&2 "* $1: updating with $3"
 146                fi
 147        else
 148                echo >&2 "* $1: storing $3"
 149        fi
 150        git-update-ref "$1" "$2" 
 151        ;;
 152
 153    refs/heads/*)
 154        # $1 is the ref being updated.
 155        # $2 is the new value for the ref.
 156        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 157        if test "$local"
 158        then
 159            # Require fast-forward.
 160            mb=$(git-merge-base "$local" "$2") &&
 161            case "$2,$mb" in
 162            $local,*)
 163                echo >&2 "* $1: same as $3"
 164                ;;
 165            *,$local)
 166                echo >&2 "* $1: fast forward to $3"
 167                echo >&2 "  from $local to $2"
 168                git-update-ref "$1" "$2" "$local"
 169                ;;
 170            *)
 171                false
 172                ;;
 173            esac || {
 174                echo >&2 "* $1: does not fast forward to $3;"
 175                case ",$force,$single_force," in
 176                *,t,*)
 177                        echo >&2 "  forcing update."
 178                        git-update-ref "$1" "$2" "$local"
 179                        ;;
 180                *)
 181                        echo >&2 "  not updating."
 182                        exit 1
 183                        ;;
 184                esac
 185            }
 186        else
 187            echo >&2 "* $1: storing $3"
 188            git-update-ref "$1" "$2"
 189        fi
 190        ;;
 191    esac
 192}
 193
 194case "$update_head_ok" in
 195'')
 196        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 197        ;;
 198esac
 199
 200# If --tags (and later --heads or --all) is specified, then we are
 201# not talking about defaults stored in Pull: line of remotes or
 202# branches file, and just fetch those and refspecs explicitly given.
 203# Otherwise we do what we always did.
 204
 205reflist=$(get_remote_refs_for_fetch "$@")
 206if test "$tags"
 207then
 208        taglist=$(IFS=" " &&
 209                  git-ls-remote $upload_pack --tags "$remote" |
 210                  while read sha1 name
 211                  do
 212                        case "$name" in
 213                        (*^*) continue ;;
 214                        esac
 215                        if git-check-ref-format "$name"
 216                        then
 217                            echo ".${name}:${name}"
 218                        else
 219                            echo >&2 "warning: tag ${name} ignored"
 220                        fi
 221                  done)
 222        if test "$#" -gt 1
 223        then
 224                # remote URL plus explicit refspecs; we need to merge them.
 225                reflist="$reflist$LF$taglist"
 226        else
 227                # No explicit refspecs; fetch tags only.
 228                reflist=$taglist
 229        fi
 230fi
 231
 232fetch_main () {
 233  reflist="$1"
 234  refs=
 235
 236  for ref in $reflist
 237  do
 238      refs="$refs$LF$ref"
 239
 240      # These are relative path from $GIT_DIR, typically starting at refs/
 241      # but may be HEAD
 242      if expr "$ref" : '\.' >/dev/null
 243      then
 244          not_for_merge=t
 245          ref=$(expr "$ref" : '\.\(.*\)')
 246      else
 247          not_for_merge=
 248      fi
 249      if expr "$ref" : '\+' >/dev/null
 250      then
 251          single_force=t
 252          ref=$(expr "$ref" : '\+\(.*\)')
 253      else
 254          single_force=
 255      fi
 256      remote_name=$(expr "$ref" : '\([^:]*\):')
 257      local_name=$(expr "$ref" : '[^:]*:\(.*\)')
 258
 259      rref="$rref$LF$remote_name"
 260
 261      # There are transports that can fetch only one head at a time...
 262      case "$remote" in
 263      http://* | https://*)
 264          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 265              curl_extra_args="-k"
 266          fi
 267          remote_name_quoted=$(perl -e '
 268              my $u = $ARGV[0];
 269              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 270              print "$u";
 271          ' "$remote_name")
 272          head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
 273          expr "$head" : "$_x40\$" >/dev/null ||
 274                  die "Failed to fetch $remote_name from $remote"
 275          echo >&2 Fetching "$remote_name from $remote" using http
 276          git-http-fetch -v -a "$head" "$remote/" || exit
 277          ;;
 278      rsync://*)
 279          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 280          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 281          head=$(git-rev-parse --verify TMP_HEAD)
 282          rm -f "$TMP_HEAD"
 283          test "$rsync_slurped_objects" || {
 284              rsync -av --ignore-existing --exclude info \
 285                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 286
 287              # Look at objects/info/alternates for rsync -- http will
 288              # support it natively and git native ones will do it on
 289              # the remote end.  Not having that file is not a crime.
 290              rsync -q "$remote/objects/info/alternates" \
 291                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 292                  rm -f "$GIT_DIR/TMP_ALT"
 293              if test -f "$GIT_DIR/TMP_ALT"
 294              then
 295                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 296                  while read alt
 297                  do
 298                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 299                      echo >&2 "Getting alternate: $alt"
 300                      rsync -av --ignore-existing --exclude info \
 301                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 302                  done
 303                  rm -f "$GIT_DIR/TMP_ALT"
 304              fi
 305              rsync_slurped_objects=t
 306          }
 307          ;;
 308      *)
 309          # We will do git native transport with just one call later.
 310          continue ;;
 311      esac
 312
 313      append_fetch_head "$head" "$remote" \
 314          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 315
 316  done
 317
 318  case "$remote" in
 319  http://* | https://* | rsync://* )
 320      ;; # we are already done.
 321  *)
 322    ( : subshell because we muck with IFS
 323      IFS="     $LF"
 324      (
 325          git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
 326      ) |
 327      while read sha1 remote_name
 328      do
 329          case "$sha1" in
 330          failed)
 331                  echo >&2 "Fetch failure: $remote"
 332                  exit 1 ;;
 333          esac
 334          found=
 335          single_force=
 336          for ref in $refs
 337          do
 338              case "$ref" in
 339              +$remote_name:*)
 340                  single_force=t
 341                  not_for_merge=
 342                  found="$ref"
 343                  break ;;
 344              .+$remote_name:*)
 345                  single_force=t
 346                  not_for_merge=t
 347                  found="$ref"
 348                  break ;;
 349              .$remote_name:*)
 350                  not_for_merge=t
 351                  found="$ref"
 352                  break ;;
 353              $remote_name:*)
 354                  not_for_merge=
 355                  found="$ref"
 356                  break ;;
 357              esac
 358          done
 359          local_name=$(expr "$found" : '[^:]*:\(.*\)')
 360          append_fetch_head "$sha1" "$remote" \
 361                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 362      done
 363    ) || exit ;;
 364  esac
 365
 366}
 367
 368fetch_main "$reflist"
 369
 370# automated tag following
 371case "$no_tags$tags" in
 372'')
 373        case "$reflist" in
 374        *:refs/*)
 375                # effective only when we are following remote branch
 376                # using local tracking branch.
 377                taglist=$(IFS=" " &&
 378                git-ls-remote $upload_pack --tags "$remote" |
 379                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 380                while read sha1 name
 381                do
 382                        test -f "$GIT_DIR/$name" && continue
 383                        git-check-ref-format "$name" || {
 384                                echo >&2 "warning: tag ${name} ignored"
 385                                continue
 386                        }
 387                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 388                        echo >&2 "Auto-following $name"
 389                        echo ".${name}:${name}"
 390                done)
 391        esac
 392        case "$taglist" in
 393        '') ;;
 394        ?*)
 395                fetch_main "$taglist" ;;
 396        esac
 397esac
 398
 399# If the original head was empty (i.e. no "master" yet), or
 400# if we were told not to worry, we do not have to check.
 401case ",$update_head_ok,$orig_head," in
 402*,, | t,* )
 403        ;;
 404*)
 405        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 406        if test "$curr_head" != "$orig_head"
 407        then
 408                git-update-ref HEAD "$orig_head"
 409                die "Cannot fetch into the current branch."
 410        fi
 411        ;;
 412esac